#!/usr/bin/env perl
# $Id: kuttuki-rss.cgi,v 1.2 2003/09/07 13:03:20 yto Exp $
# äĤ RSS (CGI)
#
# This is free software with ABSOLUTELY NO WARRANTY.
# ̵̵ݾڡ (see http://nais.to/~yto/doc/zb/0002.html)
#
#
# HTML ڡνФ: ʲΤ褦 URL ǥ롣
# http://example.com/clrss.cgi?encode=euc&url=http://example.com/~yto/cl.rdf
#
# Web ڡؤΤäĤ (): 
# <script language="JavaScript" 
# src="cgi-bin/clrss.cgi?style=js&encode=euc&url=http://example.com/aaa.rdf">
# </script>

use strict;
use Jcode;
use XML::RSS;
use CGI;
use LWP::Simple;

my $q = new CGI;

# param: style, encode, url, num
my $style = $q->param('style');
my $encode = $q->param('encode') || "euc";
my $number = $q->param('num') || -1;

my $rss_cont;
die unless (defined $q->param('url'));

$rss_cont = get($q->param('url'));

if ($rss_cont =~ s/encoding="([^u].+)"/encoding="utf-8"/i) {
    $rss_cont = Jcode->new($rss_cont)->utf8;
}

my $day_mode = ($rss_cont =~ /<title>\d{4}\D\d\d\D\d\d/) ? 1 : 0;

my $rss = XML::RSS->new;
$rss->parse($rss_cont);

my $clink = $rss->channel('link');
my $ctitle = $rss->channel('title');
my $str = qq(<table><tr><td><a href="$clink">$ctitle</a></td></tr><tr><td>);

if ($day_mode) {		# for diary type rss file
    my %items_hash;
    foreach (@{$rss->items}) {
	my ($date, $ititle) = ($_->{title} =~ /^(\d+\D\d+\D\d+).*?\s+(.+)$/);
	push @{$items_hash{$date}}, [$ititle, $_->{link}]; 
	last if ($number > 0 and --$number == 0);
    }
    $str .= "<dl>";
    foreach my $d (sort {$b cmp $a} keys %items_hash) {
	$str .= qq(<dt><a>$d</a><dd><ul>);
	foreach my $i (@{$items_hash{$d}}) {
	    $str .= qq(<li><a href="$i->[1]">$i->[0]</a>);
	}
	$str .= "</ul>";
    }
    $str .= "</dl>";
} else {			# for general rss file
    $str .= "<ul>";
    foreach (@{$rss->items}) {
	$str .= qq(<li><a href="$_->{link}">$_->{title}</a>);
	last if ($number > 0 and --$number == 0);
    }
    $str .= "</ul>";
}


$str .= "</td></tr></table>";
$str =~ s/\x27/&\#x27;/g;

Jcode::convert(\$str, $encode, "utf8");

if ($style eq "js") {
    print "Content-type: text/plain;\n\n";
    print "document.writeln('$str');\n";
} else {
    print "Content-type: text/html;\n\n";
#    print "<html><head><title>RSS</title></head><body>$str</body></html>\n";
    print << "HTML";
<html><head><title>RSS</title>
<style>
.rssbox a {text-decoration: none;}
.rssbox td {border: solid 1px #ff80ff; padding: 0.3em;}
.rssbox ul {margin: 0;}
.rssbox li {margin: 0 0 0 1em}
.rssbox dl {margin: 0;}
.rssbox dd {margin: 0 0 0 1em; font-size: smaller}
</style>
</head>
<body><div class="rssbox">$str</div></body></html>
HTML
    ;
}
